<?php

	$a = $argv[1];
	$b = $argv[2];
	$k = $argv[3]; 
	$lambda = $argv[4]; 
	
	/**
	 * Computes the Cumulative Distribution Function of a discretized Erlang distribution.
	 */ 
	function computeDiscreteErlangCDF($k, $lambda) {
		$cumulative = 0;
		for($i=0; $i<=100; $i++) {
			$cumulative = $cumulative + erlangProbability($i, $i+1, $k, $lambda);
			print $cumulative . "\n";
		}
	}

	/**
	 * Computes the density of a discretized Erlang distribution.
	 */ 
	function computeDiscreteErlangDensity($k, $lamda) {
		for($i=0; $i<=100; $i++) {
			print erlangProbability($i, $i+1, $k, $lambda) . "\n";
		}
	}

	/**
	 * Computes P(a<=X<=b), with X following an Erlang distribution of parameters k and lambda.
	 */ 
	function erlangProbability($a, $b, $k, $lambda) {
		$proba =  erlangCDF($b, $k, $lambda) - erlangCDF($a, $k, $lambda);
		return $proba;
	}

	/**
	 * Computes the Cumulative Distribution Funtion of an Erlang Distribution
	 * of parameters k and lambda for a value x.
	 * ie X follows an Erlang distribution of parameters k and lambda,
	 * and this function returns P(x<=X).
	 */ 
	function erlangCDF($x, $k, $lambda) {
		$sum = 0;
		for($i=0; $i<$k; $i++) {
			$sum = $sum + (exp(-$x*$lambda)*pow($lambda*$x,$i))/factorial($i);
		}
		return 1 - $sum;
	}

	/**
	 * Simply computes n!.
	 *
	 * Note : this is a tail recursive algorithm.
	 */ 
	function factorial($n, $res=1) {
		if($n == 0) {
			return $res;
		}
		else {
			return factorial($n-1,$res*$n);
		}
	}

